package com.zhongzheng.modules.user.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.zhongzheng.modules.user.bo.UserExamRecordAddBo;
import com.zhongzheng.modules.user.bo.UserExamRecordEditBo;
import com.zhongzheng.modules.user.bo.UserExamRecordQueryBo;
import com.zhongzheng.modules.user.domain.UserExamRecord;
import com.zhongzheng.modules.user.vo.UserExamRecordVo;

import java.util.Collection;
import java.util.List;

/**
 * 用户的题库试卷做题历史Service接口
 *
 * @author hjl
 * @date 2021-12-15
 */
public interface IUserExamRecordService extends IService<UserExamRecord> {
	/**
	 * 查询单个
	 * @return
	 */
	UserExamRecordVo queryById(Long recordId);

	UserExamRecordVo selectDetail(UserExamRecordQueryBo bo);

	/**
	 * 查询列表
	 */
	List<UserExamRecordVo> queryList(UserExamRecordQueryBo bo);

	Integer recordNum(UserExamRecordQueryBo bo);

	Long selectDoNum(UserExamRecordQueryBo bo);

	Long selectRightNum(UserExamRecordQueryBo bo);

	List<UserExamRecordVo> selectList(UserExamRecordQueryBo bo);

	/**
	 * 根据新增业务对象插入用户的题库试卷做题历史
	 * @param bo 用户的题库试卷做题历史新增业务对象
	 * @return
	 */
	Long insertByAddBo(UserExamRecordAddBo bo);

	/**
	 * 根据编辑业务对象修改用户的题库试卷做题历史
	 * @param bo 用户的题库试卷做题历史编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(UserExamRecordEditBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);
}
